

/*
To DOs
NACH ENTFERNEN Der BATTERIE WATCH Widestnde ist ein PullU ~10K gen V+ einzuten
DRIVER
CH340
http://www.jens-bretschneider.de/aktuelle-treiber-fur-seriell-zu-usb-adapter/
http://www.wch-ic.com/product/usb/ch340.asp
 http://www.wch.cn/  
CH341SER.ZIP

http://www.roboterclub-freiburg.de/projekte/asuro/index.php
http://www.chakotay.de/c-kurs/html/kap_3.htm
*/


/*
in gu8PWM_D11_Val   steht der Wert fr die IR-SENSOR Position
in gu8StateMachine steht die Aktion die Gerade durchgefhrt wird.
*/

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
//SYSINFO
#define HARDWARE	"ATMega328+UNO-R3"
#define DATUM		"13.11.2014 12:00"
#define SOFTWARE	"UNO-R3 First"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain."	
#define USEYOURS		"Use your own"
#define BAUDRATE	"9600,8,N,1"

/*
FUSES ATMEGA 8 ohne Bootloader
LOW =	FF
HIGH = 	DE
*/
/*
FUSE
http://www.engbedded.com/fusecalc/
HFUSE = CF
LFUSE = 8F
BODEN 2, 8V CKOP, Watchdog

FILE POSITION 
C:\AVR_Projekte\AA_AVR_PRJ_2014\AT8_Asuro-Avatar+Orgs-22.08.2014

22.08.2014
BESONDERHEITEN 
Das Orginal asuro.c ist modifiziert .. Nicht verwecheln
deshalb heisst es myasuro.c myasuro.h

Die entsprechenen Positionen haben 
// =/CE\=
als Zeichen
*/
/*
BESONDERHEITEN und eingefhrt

gu32_Ticks = 282 //TICK_PER_SECOND 282
wird vom 72KHz Interrupt alle /256 hochgezhlt
in ISR(SIG_OUTPUT_COMPARE2) 
	modulo UART_TXRX_Check();  

*/


/*
Alles von Arrex zum Asuro
http://www.arexx.nl/arexx.php?cmd=goto&cparam=p_asuro_downloads
FUSE SETTING FOR BOOLOADER  8MHZ Quarz

LOW FUSE 0xFF
HIGH FUSE 0xC9   // ohne BOOTRST
dies nicht //HIGH FUSE 0xC8   // mit Hacken=\/  BOOTRST

LOCK-WRITE 0xFF	//ALLES OFFEN  , mit eXtreme Burner
-->Dies NACH BootLoader Upload anwenden: 
 LOCK-WRITE 0xCF	//SPERRT BOOTBEREICH mit eXtreme Burner gelesen.

( Mit Pony Bootbereich schtzen )
BootLock11   Hcken = 0 Machen
BootLock12 Hcken = 0 Machen
BOOT-Z1,Z0=00  mit Hacken=\/ = default Value




http://www.mikrocontroller.net/articles/AVR_Bootloader_in_C_-_eine_einfache_Anleitung
BOOTLOADER 1024 words
Start ADRESS $0C00   --> geladen auf 0x1C00

Achtung: Es muss darauf geachtet werden, 
dass beim flashen der Anwendung 
nicht der Bootloader berschrieben wird.
Bei Verwendung von avrdude muss dazu die 
Option "-D" angegeben werden 
(Flash-Speicher nicht automatisch lschen).

http://www.asurowiki.de/pmwiki/pmwiki.php/Main/Bootloader
http://www.alvidi.de/data_sheets/bootloader.pdf
*/

// PWM IMMER AKTIVE


#include <stdint.h> 
#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

//#include <stdio.h>
//#include <math.h>
#include <stdlib.h>
//#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>
#include <avr\wdt.h>
#include <util\delay.h>

//#include "avr_register.h"	//with Hardware assigns
#include "main.h"			//with Hardware assigns
#include "uart.h"
#include "Befehle.h"
#include "statmach.h"
#include "debug.h"


//#include "rc5.h"


// GLOBALE VARIABLEN 

//const char MCA_DELIMITER[] PROGMEM	= ",";

volatile unsigned long gu32_Ticks; //  T2 timeCounter //extern bekannt gemacht
//volatile unsigned char gu8Count72kHz;	//Byte Variable !!

volatile unsigned long gu32BlinkTime; //extern bekannt gemacht

volatile unsigned char gu8ProgModeFlag; //Prog Mode Flags
volatile unsigned char gu8TxFlag; //tx Monitor Mode Flags
#ifdef PWM_ON_D11_USED
unsigned char gu8PWM_D11_Val = PWM_MITTE;  // Compare PWM
#endif



#ifdef MAX7219_USED
//unsigned char gu8MatrixRow;
unsigned char gu8MatrixCData;
unsigned int gu16MaxValue;
#endif


//Prototypen


//void (*bootloader)( void ) = 0x0C00U;  // Achtung Falle: Hier Word-Adresse
/*
// ****************************************************************
ISR(INT1_vect )
// *******************************************************************
{ // TASTER
GICR &= ~(1 << INT1);
MotorSpeed(0,0);
gu8StateMachine = SM_SWITCH_EVENT;
};
*/

/*
// PRESCALER 3,6864 /  32 = 115200 50-200Khz gewnscht
// REM ADC4-ADC5 = 8 BIT;
// 4+2 Channel. 
*/

// PROGRAMM SEKTION

/* uses timer2 (36kHz for IR communication */
/* counts falling and rising edge => 36kHz*2 = 72kHz */
//SIGNAL (SIG_OUTPUT_COMPARE2)

ISR(TIMER2_OVF_vect) //TIMER2_COMPA_vect TIMER2_COMPB_vect
{
gu32_Ticks++;

#ifdef PWM_ON_D11_USED   //gu8PWM_D11_Val trgt die PWMZeit fr Servos
if( (!gu32_Ticks) && !( gu32_Ticks % 5) ) //281/5 so wird ~55HZ PWM draus.
	{
	SERVO_D11_HIGH();  	//MAKRO PWM PIN +5V      
	};

//Erweiterung  =/CE\=
if( gu8Count72kHz == gu8PWM_D11_Val)
	{
	SERVO_D11_LOW();  	//MAKRO PWM PIN +5V      
	};
#endif
// GEFAHR //gu8Count72kHz = 0; fhrt zu berlaufverhinderung = STop  des 2. Tickzhlers
//Erweiterung  =/CE\=
UART_TXRX_Check();  // langsamer aber oft sehen ob was kommt an UART = Serielle Schnittstelle.
};



#ifdef INT0_USED // ON RED LED
// ****************************************************************
ISR( INT0_vect ) // Metallsucher
// *******************************************************************
{ // TASTER
//GICR &= ~(1 << INT0);
gsMetallSuch.u16_MetallPulsINT0Cnt++;
//gsGeigerCnt.u32Int0_TimeStamp = gu32_Ticks;
};
#endif


#ifdef INT1_USED // on Switch
// ****************************************************************
ISR( INT1_vect ) //Radioaktive Detect  SCHALTER  1K OHM ABKLEMMEN
// *******************************************************************
{ // TASTER
//GICR &= ~(1 << INT1);
gsGeigerCnt.u16GeigerINT1_Cnt++;
//gsGeigerCnt.u32Int0_TimeStamp = gu32_Ticks;
};
#endif



#ifdef IR_DISTANCE_USED
// *****************
uint16_t GetIR_Sens(void)
// *****************
{
//return  ADC_Average( IR_SENSOR_ADC | ADC_INTERN_BANDGAP_2_56V );
return ADC_AT8_10Bit( IR_SENSOR_ADC | ADC_5V_AN_C );
};
#endif


#ifdef ADC_USED_ENABLED
// ****************************************************
uint16_t ADC_AT8_10Bit(uint8_t u8Chan) // 0..7
// ****************************************************
{//NOW.. mit dem Chanel wird REFEREnCE Mit auf-Odiert..
// No ISR(SIG_ADC)
//DIESE DEFINES MIT OR_EN
#define ADC_BANDGAP_VOLTAGE	2.56  // zur verrechnung
#define ADC_EXTERN_5V	0x00
#define ADC_5V_AN_C		0x40 //(1<< REFS0)
#define ADC_INTERN_BANDGAP_2_56V	0xC0 //((1<< REFS1) | (1<< REFS0))	
//uint8_t u8Cnt=0;
DDRC &= ~_BV(u8Chan);  //Bit loeshcne von port A,Chanel Bit Input  
PORTC &= ~_BV(u8Chan); //Wegen Pullup abschalten

// %128 //ADCSRA = (1<< ADEN) | (1<< ADIE) | (1<< ADPS2) | (1<< ADPS1) | (1<< ADPS0);   //ADC INT EIN UND PreScaler /128
ADCSRA = (1 << ADIF) | (1<< ADEN) | (1<< ADPS2) | (1<< ADPS1);   //ADC EIN UND PreScaler /64

/*//OLD STILE  DONT USE
#ifdef ADC_EXTERN_5V_USED_ENABLED
ADMUX =  u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
#endif
#ifdef ADC_5V_AN_C_USED_ENABLED
ADMUX =  (1<< REFS0) | u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
#endif
#ifdef ADC_INTERN_BANDGAP_USED_ENABLED
ADMUX = (1<< REFS1) | (1<< REFS0) | u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
#endif
*/
//NEW STILE, append define like  "| ADC_5V_AN_C"

ADMUX = u8Chan; //Hier unbedingt die REFERENCE DEFINES mit | OR-en
_delay_us(100); // 1.4*10^-4
ADCSRA |= (1 << ADIF) |  (1<< ADSC);	//ADCSRA |= _BV(ADSC);	//Start conversion
while( ADCSRA & (1<< ADSC) )	//wait until _BV(ADSC)=0 =conversion completed
	{
	wdt_reset();
	};	
ADCSRA |= (1 << ADIF);	// clear ADCIF	
return ADC;	//ADCW; //get converted value
};
#endif


// *******************************************************************
int main(void)
// *******************************************************************
{
volatile static uint32_t u32Now;
volatile static uint32_t u32BlinkTick;
//uint8_t u8Misc;  // Alllerweltsflags fr Tests

//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
//Wichtige Schritte.. so bald wie mglich
//SFIOR = (1<<PUD); //Pullup Disable
//wdt_disable();
//DISABLE_ALL_PULLUP();

uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );
ResetRxBuff();
sei();

uart_puts_p( PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 


//strcpy_P( gcaStr, PSTR("??") );  //Zeige beim Start das Men an
//CheckOrder( gcaStr );
//  START SETTINGS
gu32BlinkTime = TICK_500MS;  //extern bekannt gemacht
#ifdef PWM_ON_D11_USED
gu8PWM_D11_Val = PWM_MITTE;
#endif

//  prepare 36kHz for IR - Communication
TCCR2A = 0;//(1 << WGM21) ;
TCCR2B = (1 << CS22) | (1 << CS21);// /256;
TIMSK2 |= (1 << TOIE2); //Overflow Interrupt Enable
/*	=/CE\=
// prepare RS232 
UCSRA = 0x00;
UCSRB = 0x00;	
UCSRC = 0x86; // No Parity | 1 Stop Bit | 8 Data Bit
UBRRL = 0xCF; // 2400bps @ 8.00MHz
*/	
ResetRxBuff();

wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
wdt_reset();   //WATCHDOG!


#ifdef INT0_USED // METTALSUCH ON RED LED
// INT o used for Puls Cnt
MCUCR |=  (1<< ISC01) | (1<< ISC00); // Rising Edge Innterrupt Sense controll
GICR |= (1 << INT0);
#endif

//gu8ProgModeFlag = AUTOMAT_RADARWACKELN_FAHREN; 
//Voreinstellung Ausgabe beimSTart
gu8TxFlag = 0; //METALL_SUCHE_TRAFFIC_ON | GEIGERZAEHLER_TRAFFIC_ON | DEBUG_TRAFFIC_ON;
gu8ProgModeFlag = 0;
gu8StateMachine = STATE_MACH_NIX;

// ************ MAIN LOOP FOR EVER *********************
for (;;)  /* loop forever */ //Aber schnell > 100.000 mal/Sekunde
// ************ MAIN LOOP FOR EVER *********************
	{	
	sei(); // es sei
 	wdt_reset();	//WATCHDOG!

// GREEN BLINK -----------------------------------------------------
	if( (gu32_Ticks - u32BlinkTick)  > gu32BlinkTime)
		{
		u32BlinkTick = gu32_Ticks;
//		TOGGLE_GREEN_LED();
		};

#ifdef TICK_MSG_USED	
// *** TICKER ****** TICKER ****** TICKER ****** TICKER ****** TICKER ****** TICKER *** 		
	if( (gu32_Ticks - u32Now)  >  TICK_1000MS ) //TICK_1000MS=282
		{
		u32Now = gu32_Ticks;
	
#ifdef DEBUG_TX_TRAFFIC_USED
if( gu8TxFlag & DEBUG_TRAFFIC_ON )
	{
	
	uart_puts_p(PSTR("State="));
	uart_puts( itoa( gu8StateMachine, gcaStr, 10 ) );
	uart_putc( 13 );

	// TEST REGISTER AUSGABE		
/*
	uart_puts_p(  PSTR(" DDRC=" ));
	uart_puts( itoa( DDRC,gcaStr, 10 ) );		
	uart_puts_p(  PSTR(" PORTC=" ));
	uart_puts( itoa( PORTC, gcaStr, 10 ) );		
*/
/*
	uart_puts_p(  PSTR(" MCUCR=" ));
	uart_puts( itoa( MCUCR, gcaStr, 10 ) );		

	uart_puts_p(  PSTR(" GICR=" ));
	uart_puts( itoa( GICR, gcaStr, 10 ) );		
*/
	};
#endif //DEBUG_TX_TRAFFIC_USED
		
		
#ifdef TX_TRAFFIC_USED	

#ifdef IR_DISTANCE_USED
		if(gu8TxFlag & IR_TRAFFIC_ON) //"IO"
			{	
			uart_puts_p(  PSTR("IR=" ));
			uart_puts( itoa( GetIR_Sens(), gcaStr, 10 ) );
			uart_putc( 13 );
			};
#endif
		
#
		
#ifdef POLL_SWITCH_USED
		if(gu8TxFlag & SW_TRAFFIC_ON)
			{
			uart_puts_p(  PSTR("Switch=" ));
			uart_puts( itoa( PollSwitch(), gcaStr, 10 ) );		
			uart_puts_p(  PSTR("  ADC=" ));
			uart_puts( itoa( ADC, gcaStr, 10 ) );		
			uart_putc( 13 );
			};
#endif //POLL_SWITCH_USED

#endif //TX_TRAFFIC_USED	
		};  //  !!!!!!!!!!!!!   TickCounter 1000MS
		
		/*
		uart_puts( ltoa( gu32_Ticks, gcaStr, 10 ) );
		uart_putc( 13 );
		uart_puts( itoa( gu8ProgModeFlag, gcaStr, 10 ) );
		uart_putc( 13 );
		*/
#endif //TICK_MSG_USED		




// -----------------------------------------------------
#ifdef TX_ODO_EVENT_USED
	if( gu8TxFlag & TX_ODO_EVENT_ON )
		{
		if( gu8ODO_Status & ODOS_LEFT_EVENT )
			{
			gu8ODO_Status &= ~ODOS_LEFT_EVENT ;
			//u8Misc
			uart_puts_p(  PSTR("EVENT LEFT=" ));
			//uart_puts( itoa( gi32ODO_Cnt_Left, gcaStr, 10 ) );
			//uart_puts_p(  PSTR(" LR=" ));
			//uart_puts( itoa( gi16ODO_Cnt_LundR, gcaStr, 10 ) );
			uart_putc( 13 );
			};

		if( gu8ODO_Status & ODOS_RIGHT_EVENT )
			{
			gu8ODO_Status &= ~ODOS_RIGHT_EVENT ;
			uart_puts_p(  PSTR("EVENT RIGHT=" ));
			//uart_puts( itoa( gi32ODO_Cnt_Right, gcaStr, 10 ) );
			//uart_puts_p(  PSTR(" LR=" ));
			//uart_puts( itoa( gi16ODO_Cnt_LundR, gcaStr, 10 ) );
			uart_putc( 13 );
			};
		};
#endif	//TX_ODO_EVENT_USED		


#ifdef POLL_SWITCH_USED
	if( PollSwitch() != gu8SwitchValue )
		{
		gu8SwitchValue = PollSwitch();
		gu8ProgModeFlag |= SWITCH_EVENT_FLAG; // EVENT TASTEREREIGNIS
		// K1 = 32, K2 = 16, K3 = 8, K4 = 4, K5 = 2, K6 = 1
		if(   (gu8SwitchValue != 0)  && (gu32_Ticks < 1500U) )
			{
			gu8StateMachine = STATE_TRY_AGAIN;
			};
		switch( gu8SwitchValue )
			{
			case 1:
				{
				break;
				};			
			case 2:
				{
				break;
				};			
			case 4:
				{
				break;
				};			
			case 8:
				{
				break;
				};			
			case 16:
				{
				break;
				};			
			case 32:
				{
				break;
				};
			};//  switch

#ifdef TX_SWITCH_EVENT_USED
		if(gu8ProgModeFlag & SW_EVENT_TRAFFIC_ON)
			{
			uart_puts_p(PSTR("SW="));
			uart_puts( itoa( gu8SwitchValue, gcaStr, 10 ) );
			uart_putc( 13 );	
			};		
#endif //TX_SWITCH_EVENT_USED
		};
#endif // POLL_SWITCH_USED 

// VERY IMPORTANT
// ***************************	
	StateMachine(); // Macht alle Action
// ***************************	
// *************************
	//Toggle_Bit( 1 ); // DEBUG ***************
// *************************
	}; //main loop Ende
};
// ******************* MAIN END ********************************************
